# Attributions

While Go does list out the dependencies in the `go.mod` file, I would
like to list them here as well for completeness. I'd also like to
attribute other projects that may have influenced the code, even if
they weren't actual dependencies.

This project uses the following actual dependencies:
* [go-sdl2][4] the Golang wrappers for SDL. (BSD 3-clause License)
* [go-gl][3] the Golang wrappers for OpenGL, specifically `v3.1/gles2`. (MIT License)

There are some [Go SDL Examples][5] and [Go OpenGL Examples][6] that I
used to get my project started. Both of them are maintained by the
same group that maintains each wrapper library.

[Open.gl][1] got me up to speed on how OpenGL 3 works with the shader
pipelines.

[LearnOpenGL.com][2] was very helpful in learning how to add lighting
to my fragment shader. I had learned the Phong shading model at
university, but this showed me how to actually apply it with OpenGL
shaders.

[The OpenGL SuperBible][7] is a book that I've had for over a
decade. After finally wrapping my head around shaders from
LearnOpenGL.com, I went back to this book and reworked a lot of the
lighting models to get them into a much more understandable state.


[1]: https://open.gl/introduction
[2]: https://learnopengl.com/Lighting/Basic-Lighting
[3]: https://github.com/go-gl/gl
[4]: https://github.com/veandco/go-sdl2
[5]: https://github.com/veandco/go-sdl2-examples
[6]: https://github.com/go-gl/example
[7]: https://www.opengl.org/sdk/docs/books/SuperBible/
