package config

import (
	"git.wisellama.rocks/Wisellama/gosimpleconf"
)

func Configure() (gosimpleconf.ConfigMap, error) {
	var err error
	configMap, err := gosimpleconf.Load("game.conf")
	if err != nil {
		return nil, err
	}

	flagMap := gosimpleconf.SetupFlagOverrides(configMap)
	configMap = gosimpleconf.ParseFlags(configMap, flagMap)

	err = SetupLogging(configMap)
	if err != nil {
		return nil, err
	}

	return configMap, nil
}
