package config

import (
	"log"
	"os"

	"git.wisellama.rocks/Wisellama/gosimpleconf"
)

func SetupLogging(configMap gosimpleconf.ConfigMap) error {

	writeToFile := gosimpleconf.Bool(configMap["log.writeToFile"])

	if writeToFile {
		logFile := configMap["log.file"]
		file, err := os.OpenFile(logFile, os.O_APPEND|os.O_CREATE|os.O_WRONLY, 0644)
		if err != nil {
			return err
		}

		log.SetOutput(file)
	}

	log.Printf("=== START %v ===", configMap["game.title"])
	return nil
}
